<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>JBuffer.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">Code Coverage for Zookeeper manuall provided Classes</a> &gt; <a href="index.source.html" class="el_package">org.apache.jute.compiler</a> &gt; <span class="el_source">JBuffer.java</span></div><h1>JBuffer.java</h1><pre class="source lang-java linenums">/**
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * &quot;License&quot;); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an &quot;AS IS&quot; BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.apache.jute.compiler;

/**
 *
 */
public class JBuffer extends JCompType {
    
    /** Creates a new instance of JBuffer */
    public JBuffer() {
<span class="nc" id="L28">        super(&quot;struct buffer&quot;, &quot; ::std::string&quot;, &quot;byte[]&quot;, &quot;byte[]&quot;, &quot;Buffer&quot;, &quot;byte[]&quot;, &quot;byte[]&quot;);</span>
<span class="nc" id="L29">    }</span>
    
    public String genCppGetSet(String fname, int fIdx) {
<span class="nc" id="L32">        String cgetFunc = &quot;  virtual const &quot;+getCppType()+&quot;&amp; get&quot;+fname+&quot;() const {\n&quot;;</span>
<span class="nc" id="L33">        cgetFunc += &quot;    return m&quot;+fname+&quot;;\n&quot;;</span>
<span class="nc" id="L34">        cgetFunc += &quot;  }\n&quot;;</span>
<span class="nc" id="L35">        String getFunc = &quot;  virtual &quot;+getCppType()+&quot;&amp; get&quot;+fname+&quot;() {\n&quot;;</span>
<span class="nc" id="L36">        getFunc += &quot;    bs_.set(&quot;+fIdx+&quot;);return m&quot;+fname+&quot;;\n&quot;;</span>
<span class="nc" id="L37">        getFunc += &quot;  }\n&quot;;</span>
<span class="nc" id="L38">        return cgetFunc + getFunc;</span>
    }
    
    public String getSignature() {
<span class="nc" id="L42">        return &quot;B&quot;;</span>
    }
    
    public String genJavaReadWrapper(String fname, String tag, boolean decl) {
<span class="nc" id="L46">        String ret = &quot;&quot;;</span>
<span class="nc bnc" id="L47" title="All 2 branches missed.">        if (decl) {</span>
<span class="nc" id="L48">            ret = &quot;    byte[] &quot;+fname+&quot;;\n&quot;;</span>
        }
<span class="nc" id="L50">        return ret + &quot;        &quot;+fname+&quot;=a_.readBuffer(\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }
    
    public String genJavaWriteWrapper(String fname, String tag) {
<span class="nc" id="L54">        return &quot;        a_.writeBuffer(&quot;+fname+&quot;,\&quot;&quot;+tag+&quot;\&quot;);\n&quot;;</span>
    }
    
    public String genJavaCompareTo(String fname, String other) {
<span class="nc" id="L58">      StringBuilder sb = new StringBuilder();</span>
<span class="nc" id="L59">      sb.append(&quot;    {\n&quot;);</span>
<span class="nc" id="L60">      sb.append(&quot;      byte[] my = &quot;+fname+&quot;;\n&quot;);</span>
<span class="nc" id="L61">      sb.append(&quot;      byte[] ur = &quot;+other+&quot;;\n&quot;);</span>
<span class="nc" id="L62">      sb.append(&quot;      ret = org.apache.jute.Utils.compareBytes(my,0,my.length,ur,0,ur.length);\n&quot;);</span>
<span class="nc" id="L63">      sb.append(&quot;    }\n&quot;);</span>
<span class="nc" id="L64">      return sb.toString();</span>
    }
    
    public String genJavaCompareTo(String fname) {
<span class="nc" id="L68">        return genJavaCompareTo(fname, &quot;peer.&quot;+fname);</span>
    }
    public String genJavaCompareToWrapper(String fname, String other) {
<span class="nc" id="L71">      return &quot;    &quot;+genJavaCompareTo(fname, other);</span>
    }
    
    public String genJavaEquals(String fname, String peer) {
<span class="nc" id="L75">        return &quot;    ret = org.apache.jute.Utils.bufEquals(&quot;+fname+&quot;,&quot;+peer+&quot;);\n&quot;;</span>
    }
    
    public String genJavaHashCode(String fname) {
<span class="nc" id="L79">        return &quot;    ret = java.util.Arrays.toString(&quot;+fname+&quot;).hashCode();\n&quot;;</span>
    }
    
    public String genJavaSlurpBytes(String b, String s, String l) {
<span class="nc" id="L83">      StringBuilder sb = new StringBuilder();</span>
<span class="nc" id="L84">      sb.append(&quot;        {\n&quot;);</span>
<span class="nc" id="L85">      sb.append(&quot;           int i = org.apache.jute.Utils.readVInt(&quot;+b+&quot;, &quot;+s+&quot;);\n&quot;);</span>
<span class="nc" id="L86">      sb.append(&quot;           int z = WritableUtils.getVIntSize(i);\n&quot;);</span>
<span class="nc" id="L87">      sb.append(&quot;           &quot;+s+&quot; += z+i; &quot;+l+&quot; -= (z+i);\n&quot;);</span>
<span class="nc" id="L88">      sb.append(&quot;        }\n&quot;);</span>
<span class="nc" id="L89">      return sb.toString();</span>
    }
    
    public String genJavaCompareBytes() {
<span class="nc" id="L93">      StringBuilder sb = new StringBuilder();</span>
<span class="nc" id="L94">      sb.append(&quot;        {\n&quot;);</span>
<span class="nc" id="L95">      sb.append(&quot;           int i1 = org.apache.jute.Utils.readVInt(b1, s1);\n&quot;);</span>
<span class="nc" id="L96">      sb.append(&quot;           int i2 = org.apache.jute.Utils.readVInt(b2, s2);\n&quot;);</span>
<span class="nc" id="L97">      sb.append(&quot;           int z1 = WritableUtils.getVIntSize(i1);\n&quot;);</span>
<span class="nc" id="L98">      sb.append(&quot;           int z2 = WritableUtils.getVIntSize(i2);\n&quot;);</span>
<span class="nc" id="L99">      sb.append(&quot;           s1+=z1; s2+=z2; l1-=z1; l2-=z2;\n&quot;);</span>
<span class="nc" id="L100">      sb.append(&quot;           int r1 = org.apache.jute.Utils.compareBytes(b1,s1,l1,b2,s2,l2);\n&quot;);</span>
<span class="nc" id="L101">      sb.append(&quot;           if (r1 != 0) { return (r1&lt;0)?-1:0; }\n&quot;);</span>
<span class="nc" id="L102">      sb.append(&quot;           s1+=i1; s2+=i2; l1-=i1; l1-=i2;\n&quot;);</span>
<span class="nc" id="L103">      sb.append(&quot;        }\n&quot;);</span>
<span class="nc" id="L104">      return sb.toString();</span>
    }
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.eclemma.org/jacoco">JaCoCo</a> 0.7.7.201606060606</span></div></body></html>